/* InputDeviceMonitor.c generated by valac 0.38.10, the Vala compiler
 * generated from InputDeviceMonitor.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <glib/gi18n-lib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>


#define SOUND_TYPE_INPUT_DEVICE_MONITOR (sound_input_device_monitor_get_type ())
#define SOUND_INPUT_DEVICE_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitor))
#define SOUND_INPUT_DEVICE_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitorClass))
#define SOUND_IS_INPUT_DEVICE_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_INPUT_DEVICE_MONITOR))
#define SOUND_IS_INPUT_DEVICE_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_INPUT_DEVICE_MONITOR))
#define SOUND_INPUT_DEVICE_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitorClass))

typedef struct _SoundInputDeviceMonitor SoundInputDeviceMonitor;
typedef struct _SoundInputDeviceMonitorClass SoundInputDeviceMonitorClass;
typedef struct _SoundInputDeviceMonitorPrivate SoundInputDeviceMonitorPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_INPUT_DEVICE_MONITOR_0_PROPERTY,
	SOUND_INPUT_DEVICE_MONITOR_NUM_PROPERTIES
};
static GParamSpec* sound_input_device_monitor_properties[SOUND_INPUT_DEVICE_MONITOR_NUM_PROPERTIES];
#define _pa_stream_unref0(var) ((var == NULL) ? NULL : (var = (pa_stream_unref (var), NULL)))

#define SOUND_TYPE_PULSE_AUDIO_MANAGER (sound_pulse_audio_manager_get_type ())
#define SOUND_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager))
#define SOUND_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))
#define SOUND_IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))

typedef struct _SoundPulseAudioManager SoundPulseAudioManager;
typedef struct _SoundPulseAudioManagerClass SoundPulseAudioManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
enum  {
	SOUND_INPUT_DEVICE_MONITOR_UPDATE_FRACTION_SIGNAL,
	SOUND_INPUT_DEVICE_MONITOR_NUM_SIGNALS
};
static guint sound_input_device_monitor_signals[SOUND_INPUT_DEVICE_MONITOR_NUM_SIGNALS] = {0};

struct _SoundInputDeviceMonitor {
	GObject parent_instance;
	SoundInputDeviceMonitorPrivate * priv;
};

struct _SoundInputDeviceMonitorClass {
	GObjectClass parent_class;
};

struct _SoundInputDeviceMonitorPrivate {
	pa_stream* steam;
	SoundDevice* device;
	gboolean allow_record;
};


static gpointer sound_input_device_monitor_parent_class = NULL;

GType sound_input_device_monitor_get_type (void) G_GNUC_CONST;
GType sound_device_get_type (void) G_GNUC_CONST;
#define SOUND_INPUT_DEVICE_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitorPrivate))
SoundInputDeviceMonitor* sound_input_device_monitor_new (void);
SoundInputDeviceMonitor* sound_input_device_monitor_construct (GType object_type);
void sound_input_device_monitor_stop_record (SoundInputDeviceMonitor* self);
void sound_input_device_monitor_start_record (SoundInputDeviceMonitor* self);
GType sound_pulse_audio_manager_get_type (void) G_GNUC_CONST;
SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void);
pa_context* sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self);
static void sound_input_device_monitor_steam_read_callback (SoundInputDeviceMonitor* self, pa_stream* s, gsize nbytes);
static void _sound_input_device_monitor_steam_read_callback_pa_stream_requestcb (pa_stream* s, gsize nbytes, gpointer self);
static void sound_input_device_monitor_steam_suspended_callback (SoundInputDeviceMonitor* self, pa_stream* s);
static void _sound_input_device_monitor_steam_suspended_callback_pa_stream_notifycb (pa_stream* s, gpointer self);
guint32 sound_device_get_index (SoundDevice* self);
void sound_input_device_monitor_set_device (SoundInputDeviceMonitor* self, SoundDevice* device);
static void sound_input_device_monitor_finalize (GObject * obj);


SoundInputDeviceMonitor* sound_input_device_monitor_construct (GType object_type) {
	SoundInputDeviceMonitor * self = NULL;
	self = (SoundInputDeviceMonitor*) g_object_new (object_type, NULL);
	return self;
}


SoundInputDeviceMonitor* sound_input_device_monitor_new (void) {
	return sound_input_device_monitor_construct (SOUND_TYPE_INPUT_DEVICE_MONITOR);
}


void sound_input_device_monitor_stop_record (SoundInputDeviceMonitor* self) {
	gboolean _tmp0_;
	pa_stream* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->allow_record;
	if (_tmp0_ == FALSE) {
		return;
	}
	self->priv->allow_record = FALSE;
	_tmp1_ = self->priv->steam;
	if (_tmp1_ != NULL) {
		pa_stream* _tmp2_;
		_tmp2_ = self->priv->steam;
		pa_stream_disconnect (_tmp2_);
		_pa_stream_unref0 (self->priv->steam);
		self->priv->steam = NULL;
	}
}


static void _sound_input_device_monitor_steam_read_callback_pa_stream_requestcb (pa_stream* s, gsize nbytes, gpointer self) {
	sound_input_device_monitor_steam_read_callback ((SoundInputDeviceMonitor*) self, s, nbytes);
}


static void _sound_input_device_monitor_steam_suspended_callback_pa_stream_notifycb (pa_stream* s, gpointer self) {
	sound_input_device_monitor_steam_suspended_callback ((SoundInputDeviceMonitor*) self, s);
}


void sound_input_device_monitor_start_record (SoundInputDeviceMonitor* self) {
	SoundDevice* _tmp0_;
	pa_stream* _tmp1_;
	pa_context* c = NULL;
	SoundPulseAudioManager* _tmp3_;
	pa_context* _tmp4_;
	pa_context* _tmp5_;
	pa_sample_spec ss = {0};
	pa_proplist* props = NULL;
	pa_proplist* _tmp6_;
	pa_proplist* _tmp7_;
	pa_proplist* _tmp8_;
	pa_proplist* _tmp9_;
	pa_proplist* _tmp10_;
	pa_context* _tmp11_;
	pa_sample_spec _tmp12_;
	pa_proplist* _tmp13_;
	pa_stream* _tmp14_;
	pa_stream* _tmp15_;
	pa_stream* _tmp16_;
	pa_buffer_attr a = {0};
	pa_stream* _tmp17_;
	SoundDevice* _tmp18_;
	guint32 _tmp19_;
	guint32 _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	pa_buffer_attr _tmp23_;
	g_return_if_fail (self != NULL);
	self->priv->allow_record = TRUE;
	_tmp0_ = self->priv->device;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->steam;
	if (_tmp1_ != NULL) {
		pa_stream* _tmp2_;
		_tmp2_ = self->priv->steam;
		pa_stream_disconnect (_tmp2_);
		_pa_stream_unref0 (self->priv->steam);
		self->priv->steam = NULL;
	}
	_tmp3_ = sound_pulse_audio_manager_get_default ();
	_tmp4_ = sound_pulse_audio_manager_get_context (_tmp3_);
	_tmp5_ = _tmp4_;
	c = _tmp5_;
	pa_sample_spec_init (&ss);
	ss.format = PA_SAMPLE_FLOAT32NE;
	ss.rate = (guint32) 25;
	ss.channels = (guint8) 1;
	_tmp6_ = pa_proplist_new ();
	props = _tmp6_;
	_tmp7_ = props;
	pa_proplist_sets (_tmp7_, PA_PROP_APPLICATION_NAME, "Switchboard sound");
	_tmp8_ = props;
	pa_proplist_sets (_tmp8_, PA_PROP_APPLICATION_ID, "org.pantheon.switchboard.plug.sound");
	_tmp9_ = props;
	pa_proplist_sets (_tmp9_, PA_PROP_APPLICATION_ICON_NAME, "multimedia-volume-control");
	_tmp10_ = props;
	pa_proplist_sets (_tmp10_, PA_PROP_APPLICATION_VERSION, "0.1");
	_tmp11_ = c;
	_tmp12_ = ss;
	_tmp13_ = props;
	_tmp14_ = pa_stream_new_with_proplist (_tmp11_, _ ("Peak detect"), &_tmp12_, NULL, _tmp13_);
	_pa_stream_unref0 (self->priv->steam);
	self->priv->steam = _tmp14_;
	_tmp15_ = self->priv->steam;
	pa_stream_set_read_callback (_tmp15_, _sound_input_device_monitor_steam_read_callback_pa_stream_requestcb, self);
	_tmp16_ = self->priv->steam;
	pa_stream_set_suspended_callback (_tmp16_, _sound_input_device_monitor_steam_suspended_callback_pa_stream_notifycb, self);
	memset (&a, 0, sizeof (pa_buffer_attr));
	a.maxlength = G_MAXUINT32;
	a.fragsize = (guint32) sizeof (gfloat);
	_tmp17_ = self->priv->steam;
	_tmp18_ = self->priv->device;
	_tmp19_ = sound_device_get_index (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strdup_printf ("%u", (guint) _tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = a;
	pa_stream_connect_record (_tmp17_, _tmp22_, &_tmp23_, (PA_STREAM_DONT_MOVE | PA_STREAM_PEAK_DETECT) | PA_STREAM_ADJUST_LATENCY);
	_g_free0 (_tmp22_);
	_pa_proplist_free0 (props);
}


void sound_input_device_monitor_set_device (SoundInputDeviceMonitor* self, SoundDevice* device) {
	SoundDevice* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = device;
	self->priv->device = _tmp0_;
	_tmp1_ = self->priv->allow_record;
	if (_tmp1_) {
		sound_input_device_monitor_start_record (self);
	} else {
		sound_input_device_monitor_stop_record (self);
	}
}


static void sound_input_device_monitor_steam_read_callback (SoundInputDeviceMonitor* self, pa_stream* s, gsize nbytes) {
	void* data = NULL;
	pa_stream* _tmp0_;
	void* _tmp1_ = NULL;
	gsize _tmp2_ = 0UL;
	gint _tmp3_;
	void* _tmp4_;
	gfloat v = 0.0F;
	void* _tmp6_;
	gsize _tmp7_;
	gfloat _tmp8_;
	pa_stream* _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (s != NULL);
	_tmp0_ = s;
	_tmp3_ = pa_stream_peek (_tmp0_, &_tmp1_, &_tmp2_);
	data = _tmp1_;
	nbytes = _tmp2_;
	if (_tmp3_ < 0) {
		g_warning ("InputDeviceMonitor.vala:100: Failed to read data from stream");
		return;
	}
	_tmp4_ = data;
	if (_tmp4_ == NULL) {
		pa_stream* _tmp5_;
		_tmp5_ = s;
		pa_stream_drop (_tmp5_);
		return;
	}
	_tmp6_ = data;
	_tmp7_ = nbytes;
	_tmp8_ = ((gfloat*) _tmp6_)[(_tmp7_ / sizeof (gfloat)) - 1];
	v = _tmp8_;
	_tmp9_ = s;
	pa_stream_drop (_tmp9_);
	_tmp10_ = v;
	if (_tmp10_ < ((gfloat) 0)) {
		v = (gfloat) 0;
	}
	_tmp11_ = v;
	if (_tmp11_ > ((gfloat) 1)) {
		v = (gfloat) 1;
	}
	_tmp12_ = v;
	g_signal_emit (self, sound_input_device_monitor_signals[SOUND_INPUT_DEVICE_MONITOR_UPDATE_FRACTION_SIGNAL], 0, _tmp12_);
}


static void sound_input_device_monitor_steam_suspended_callback (SoundInputDeviceMonitor* self, pa_stream* s) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (s != NULL);
	g_signal_emit (self, sound_input_device_monitor_signals[SOUND_INPUT_DEVICE_MONITOR_UPDATE_FRACTION_SIGNAL], 0, (gfloat) 0);
}


static void sound_input_device_monitor_class_init (SoundInputDeviceMonitorClass * klass) {
	sound_input_device_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SoundInputDeviceMonitorPrivate));
	G_OBJECT_CLASS (klass)->finalize = sound_input_device_monitor_finalize;
	sound_input_device_monitor_signals[SOUND_INPUT_DEVICE_MONITOR_UPDATE_FRACTION_SIGNAL] = g_signal_new ("update-fraction", SOUND_TYPE_INPUT_DEVICE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__FLOAT, G_TYPE_NONE, 1, G_TYPE_FLOAT);
}


static void sound_input_device_monitor_instance_init (SoundInputDeviceMonitor * self) {
	self->priv = SOUND_INPUT_DEVICE_MONITOR_GET_PRIVATE (self);
	self->priv->allow_record = FALSE;
}


static void sound_input_device_monitor_finalize (GObject * obj) {
	SoundInputDeviceMonitor * self;
	pa_stream* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitor);
	_tmp0_ = self->priv->steam;
	if (_tmp0_ != NULL) {
		pa_stream* _tmp1_;
		pa_stream* _tmp2_;
		pa_stream* _tmp3_;
		_tmp1_ = self->priv->steam;
		pa_stream_set_read_callback (_tmp1_, NULL, NULL);
		_tmp2_ = self->priv->steam;
		pa_stream_set_suspended_callback (_tmp2_, NULL, NULL);
		_tmp3_ = self->priv->steam;
		pa_stream_disconnect (_tmp3_);
	}
	_pa_stream_unref0 (self->priv->steam);
	G_OBJECT_CLASS (sound_input_device_monitor_parent_class)->finalize (obj);
}


GType sound_input_device_monitor_get_type (void) {
	static volatile gsize sound_input_device_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&sound_input_device_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundInputDeviceMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_input_device_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundInputDeviceMonitor), 0, (GInstanceInitFunc) sound_input_device_monitor_instance_init, NULL };
		GType sound_input_device_monitor_type_id;
		sound_input_device_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundInputDeviceMonitor", &g_define_type_info, 0);
		g_once_init_leave (&sound_input_device_monitor_type_id__volatile, sound_input_device_monitor_type_id);
	}
	return sound_input_device_monitor_type_id__volatile;
}



