/* PulseAudioManager.c generated by valac 0.38.10, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/*
 * Vocabulary of PulseAudio:
 *  - Source: Input (microphone)
 *  - Sink: Output (speaker)
 */

#include <glib.h>
#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "pulse/ext-stream-restore.h"
#include <float.h>
#include <math.h>


#define SOUND_TYPE_PULSE_AUDIO_MANAGER (sound_pulse_audio_manager_get_type ())
#define SOUND_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager))
#define SOUND_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))
#define SOUND_IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))

typedef struct _SoundPulseAudioManager SoundPulseAudioManager;
typedef struct _SoundPulseAudioManagerClass SoundPulseAudioManagerClass;
typedef struct _SoundPulseAudioManagerPrivate SoundPulseAudioManagerPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_0_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _SoundDevicePrivate SoundDevicePrivate;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundPulseAudioManagerReconnectToPulseData SoundPulseAudioManagerReconnectToPulseData;
typedef struct _Block2Data Block2Data;

#define SOUND_DEVICE_TYPE_PORT (sound_device_port_get_type ())
#define SOUND_DEVICE_PORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePort))
#define SOUND_DEVICE_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))
#define SOUND_DEVICE_IS_PORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_IS_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_PORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))

typedef struct _SoundDevicePort SoundDevicePort;
typedef struct _SoundDevicePortClass SoundDevicePortClass;
typedef struct _SoundDevicePortPrivate SoundDevicePortPrivate;
#define _sound_device_port_unref0(var) ((var == NULL) ? NULL : (var = (sound_device_port_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL,
	SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS
};
static guint sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS] = {0};

struct _SoundPulseAudioManager {
	GObject parent_instance;
	SoundPulseAudioManagerPrivate * priv;
};

struct _SoundPulseAudioManagerClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerPrivate {
	pa_context* _context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
	GeeHashMap* input_devices;
	GeeHashMap* output_devices;
	SoundDevice* _default_output;
	SoundDevice* _default_input;
	gchar* default_source_name;
	gchar* default_sink_name;
	GeeHashMap* volume_operations;
};

struct _Block1Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundDevice {
	GObject parent_instance;
	SoundDevicePrivate * priv;
	GeeLinkedList* volume_operations;
};

struct _SoundDeviceClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	gboolean _tmp0_;
	pa_context* _tmp1_;
	pa_proplist* props;
	pa_proplist* _tmp2_;
	pa_proplist* _tmp3_;
	pa_glib_mainloop* _tmp4_;
	pa_mainloop_api* _tmp5_;
	pa_proplist* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	pa_context* _tmp10_;
	gint _tmp11_;
	pa_context* _tmp12_;
	int _tmp13_;
	const gchar* _tmp14_;
};

struct _Block2Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundDevicePort {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SoundDevicePortPrivate * priv;
	gchar* name;
	gchar* description;
	guint32 priority;
};

struct _SoundDevicePortClass {
	GTypeClass parent_class;
	void (*finalize) (SoundDevicePort *self);
};

struct _Block3Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};


static gpointer sound_pulse_audio_manager_parent_class = NULL;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam = NULL;

GType sound_pulse_audio_manager_get_type (void) G_GNUC_CONST;
GType sound_device_get_type (void) G_GNUC_CONST;
#define SOUND_PULSE_AUDIO_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerPrivate))
SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_new (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type);
void sound_pulse_audio_manager_start (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self, GAsyncResult* _res_);
void sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self, SoundDevice* device);
gboolean sound_device_get_input (SoundDevice* self);
const gchar* sound_device_get_name (SoundDevice* self);
pa_context* sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self, pa_context* c, pa_ext_stream_restore_info* info, gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c, pa_ext_stream_restore_info* info, gint eol, gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self, pa_context* c, pa_ext_stream_restore_info* info, gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c, pa_ext_stream_restore_info* info, gint eol, gpointer self);
void sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self, SoundDevice* device, gboolean mute);
guint32 sound_device_get_index (SoundDevice* self);
void sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self, SoundDevice* device, gdouble volume);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block1Data* _data1_, pa_operation* operation);
static gboolean ___lambda7__gee_forall_func (gpointer g, gpointer self);
void sound_device_get_cvolume (SoundDevice* self, pa_cvolume * result);
static pa_volume_t sound_pulse_audio_manager_double_to_volume (gdouble vol);
void sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self, SoundDevice* device, gfloat balance);
void sound_device_get_channel_map (SoundDevice* self, pa_channel_map * result);
static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static void sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper (GObject *source_object, GAsyncResult *res, void *user_data);
static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_);
static void sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self, pa_context* value);
static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self, pa_context* c);
static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c, gpointer self);
static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self, pa_context* c, pa_subscription_event_type_t t, guint32 index);
static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c, pa_subscription_event_type_t t, guint32 idx, gpointer self);
static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self, pa_context* c, pa_server_info* i);
static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c, pa_server_info* i, gpointer self);
static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self, pa_context* c, pa_sink_info* i, gint eol);
static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c, pa_sink_info* i, gint eol, gpointer self);
static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self, pa_context* c, pa_source_info* i, gint eol);
static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c, pa_source_info* i, gint eol, gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
SoundDevice* sound_device_new (guint32 index);
SoundDevice* sound_device_construct (GType object_type, guint32 index);
void sound_device_set_input (SoundDevice* self, gboolean value);
void sound_device_set_name (SoundDevice* self, const gchar* value);
void sound_device_set_display_name (SoundDevice* self, const gchar* value);
void sound_device_set_is_muted (SoundDevice* self, gboolean value);
void sound_device_set_cvolume (SoundDevice* self, pa_cvolume * value);
void sound_device_set_channel_map (SoundDevice* self, pa_channel_map * value);
void sound_device_set_balance (SoundDevice* self, gfloat value);
static gboolean __lambda6_ (Block2Data* _data2_, pa_operation* operation);
static gboolean ___lambda6__gee_forall_func (gpointer g, gpointer self);
gpointer sound_device_port_ref (gpointer instance);
void sound_device_port_unref (gpointer instance);
GParamSpec* sound_device_param_spec_port (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sound_device_value_set_port (GValue* value, gpointer v_object);
void sound_device_value_take_port (GValue* value, gpointer v_object);
gpointer sound_device_value_get_port (const GValue* value);
GType sound_device_port_get_type (void) G_GNUC_CONST;
GeeArrayList* sound_device_get_ports (SoundDevice* self);
void sound_device_set_default_port (SoundDevice* self, SoundDevicePort* value);
SoundDevicePort* sound_device_port_new (void);
SoundDevicePort* sound_device_port_construct (GType object_type);
static gdouble sound_pulse_audio_manager_volume_to_double (pa_volume_t vol);
void sound_device_set_volume (SoundDevice* self, gdouble value);
void sound_device_set_form_factor (SoundDevice* self, const gchar* value);
void sound_device_set_is_default (SoundDevice* self, gboolean value);
gboolean sound_device_get_is_default (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self, SoundDevice* value);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block3Data* _data3_, pa_operation* operation);
static gboolean ___lambda5__gee_forall_func (gpointer g, gpointer self);
static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self, SoundDevice* value);
SoundDevice* sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self);
SoundDevice* sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self);
static GObject * sound_pulse_audio_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void sound_pulse_audio_manager_finalize (GObject * obj);
static void _vala_sound_pulse_audio_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_sound_pulse_audio_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void) {
	SoundPulseAudioManager* result = NULL;
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp2_;
	_tmp0_ = sound_pulse_audio_manager_pam;
	if (_tmp0_ == NULL) {
		SoundPulseAudioManager* _tmp1_;
		_tmp1_ = sound_pulse_audio_manager_new ();
		_g_object_unref0 (sound_pulse_audio_manager_pam);
		sound_pulse_audio_manager_pam = _tmp1_;
	}
	_tmp2_ = sound_pulse_audio_manager_pam;
	result = _tmp2_;
	return result;
}


static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type) {
	SoundPulseAudioManager * self = NULL;
	self = (SoundPulseAudioManager*) g_object_new (object_type, NULL);
	return self;
}


static SoundPulseAudioManager* sound_pulse_audio_manager_new (void) {
	return sound_pulse_audio_manager_construct (SOUND_TYPE_PULSE_AUDIO_MANAGER);
}


void sound_pulse_audio_manager_start (SoundPulseAudioManager* self) {
	g_return_if_fail (self != NULL);
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
}


static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c, pa_ext_stream_restore_info* info, gint eol, gpointer self) {
	sound_pulse_audio_manager_ext_stream_restore_read_source_callback ((SoundPulseAudioManager*) self, c, info, eol);
}


static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c, pa_ext_stream_restore_info* info, gint eol, gpointer self) {
	sound_pulse_audio_manager_ext_stream_restore_read_sink_callback ((SoundPulseAudioManager*) self, c, info, eol);
}


void sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self, SoundDevice* device) {
	SoundDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = device;
	_tmp1_ = sound_device_get_input (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		SoundDevice* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		pa_operation* ope = NULL;
		pa_context* _tmp7_;
		SoundDevice* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		pa_operation* _tmp11_;
		pa_operation* _tmp12_;
		_tmp3_ = device;
		_tmp4_ = sound_device_get_name (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (self->priv->default_source_name);
		self->priv->default_source_name = _tmp6_;
		_tmp7_ = self->priv->_context;
		_tmp8_ = device;
		_tmp9_ = sound_device_get_name (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = pa_context_set_default_source (_tmp7_, _tmp10_, NULL, NULL);
		ope = _tmp11_;
		_tmp12_ = ope;
		if (_tmp12_ != NULL) {
			pa_context* _tmp13_;
			pa_operation* _tmp14_;
			pa_operation* _tmp15_;
			_tmp13_ = self->priv->_context;
			_tmp14_ = pa_ext_stream_restore_read (_tmp13_, _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb, self);
			_tmp15_ = _tmp14_;
			_pa_operation_unref0 (_tmp15_);
		}
		_pa_operation_unref0 (ope);
	} else {
		SoundDevice* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		pa_operation* ope = NULL;
		pa_context* _tmp20_;
		SoundDevice* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		pa_operation* _tmp24_;
		pa_operation* _tmp25_;
		_tmp16_ = device;
		_tmp17_ = sound_device_get_name (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strdup (_tmp18_);
		_g_free0 (self->priv->default_sink_name);
		self->priv->default_sink_name = _tmp19_;
		_tmp20_ = self->priv->_context;
		_tmp21_ = device;
		_tmp22_ = sound_device_get_name (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = pa_context_set_default_sink (_tmp20_, _tmp23_, NULL, NULL);
		ope = _tmp24_;
		_tmp25_ = ope;
		if (_tmp25_ != NULL) {
			pa_context* _tmp26_;
			pa_operation* _tmp27_;
			pa_operation* _tmp28_;
			_tmp26_ = self->priv->_context;
			_tmp27_ = pa_ext_stream_restore_read (_tmp26_, _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb, self);
			_tmp28_ = _tmp27_;
			_pa_operation_unref0 (_tmp28_);
		}
		_pa_operation_unref0 (ope);
	}
}


void sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self, SoundDevice* device, gboolean mute) {
	SoundDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = device;
	_tmp1_ = sound_device_get_input (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		pa_context* _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		gboolean _tmp7_;
		pa_operation* _tmp8_;
		pa_operation* _tmp9_;
		_tmp3_ = self->priv->_context;
		_tmp4_ = device;
		_tmp5_ = sound_device_get_index (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = mute;
		_tmp8_ = pa_context_set_source_mute_by_index (_tmp3_, _tmp6_, _tmp7_, NULL, NULL);
		_tmp9_ = _tmp8_;
		_pa_operation_unref0 (_tmp9_);
	} else {
		pa_context* _tmp10_;
		SoundDevice* _tmp11_;
		guint32 _tmp12_;
		guint32 _tmp13_;
		gboolean _tmp14_;
		pa_operation* _tmp15_;
		pa_operation* _tmp16_;
		_tmp10_ = self->priv->_context;
		_tmp11_ = device;
		_tmp12_ = sound_device_get_index (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = mute;
		_tmp15_ = pa_context_set_sink_mute_by_index (_tmp10_, _tmp13_, _tmp14_, NULL, NULL);
		_tmp16_ = _tmp15_;
		_pa_operation_unref0 (_tmp16_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->device);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean __lambda7_ (Block1Data* _data1_, pa_operation* operation) {
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	pa_operation* _tmp0_;
	pa_operation_state_t _tmp1_;
	SoundDevice* _tmp3_;
	GeeLinkedList* _tmp4_;
	pa_operation* _tmp5_;
	self = _data1_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	_tmp0_ = operation;
	_tmp1_ = pa_operation_get_state (_tmp0_);
	if (_tmp1_ == PA_OPERATION_RUNNING) {
		pa_operation* _tmp2_;
		_tmp2_ = operation;
		pa_operation_cancel (_tmp2_);
	}
	_tmp3_ = _data1_->device;
	_tmp4_ = _tmp3_->volume_operations;
	_tmp5_ = operation;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp4_, _tmp5_);
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}


static gboolean ___lambda7__gee_forall_func (gpointer g, gpointer self) {
	gboolean result;
	result = __lambda7_ (self, (pa_operation*) g);
	return result;
}


void sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self, SoundDevice* device, gdouble volume) {
	Block1Data* _data1_;
	SoundDevice* _tmp0_;
	SoundDevice* _tmp1_;
	SoundDevice* _tmp2_;
	GeeLinkedList* _tmp3_;
	pa_cvolume cvol = {0};
	SoundDevice* _tmp4_;
	pa_cvolume _tmp5_ = {0};
	pa_cvolume _tmp6_;
	gdouble _tmp7_;
	pa_volume_t _tmp8_;
	pa_operation* operation = NULL;
	SoundDevice* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	pa_operation* _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = device;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data1_->device);
	_data1_->device = _tmp1_;
	_tmp2_ = _data1_->device;
	_tmp3_ = _tmp2_->volume_operations;
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp3_, ___lambda7__gee_forall_func, _data1_);
	_tmp4_ = _data1_->device;
	sound_device_get_cvolume (_tmp4_, &_tmp5_);
	_tmp6_ = _tmp5_;
	cvol = _tmp6_;
	_tmp7_ = volume;
	_tmp8_ = sound_pulse_audio_manager_double_to_volume (_tmp7_);
	pa_cvolume_scale (&cvol, _tmp8_);
	operation = NULL;
	_tmp9_ = _data1_->device;
	_tmp10_ = sound_device_get_input (_tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		pa_context* _tmp12_;
		SoundDevice* _tmp13_;
		guint32 _tmp14_;
		guint32 _tmp15_;
		pa_cvolume _tmp16_;
		pa_operation* _tmp17_;
		_tmp12_ = self->priv->_context;
		_tmp13_ = _data1_->device;
		_tmp14_ = sound_device_get_index (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = cvol;
		_tmp17_ = pa_context_set_source_volume_by_index (_tmp12_, _tmp15_, &_tmp16_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp17_;
	} else {
		pa_context* _tmp18_;
		SoundDevice* _tmp19_;
		guint32 _tmp20_;
		guint32 _tmp21_;
		pa_cvolume _tmp22_;
		pa_operation* _tmp23_;
		_tmp18_ = self->priv->_context;
		_tmp19_ = _data1_->device;
		_tmp20_ = sound_device_get_index (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = cvol;
		_tmp23_ = pa_context_set_sink_volume_by_index (_tmp18_, _tmp21_, &_tmp22_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp23_;
	}
	_tmp24_ = operation;
	if (_tmp24_ != NULL) {
		SoundDevice* _tmp25_;
		GeeLinkedList* _tmp26_;
		pa_operation* _tmp27_;
		_tmp25_ = _data1_->device;
		_tmp26_ = _tmp25_->volume_operations;
		_tmp27_ = operation;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
	}
	_pa_operation_unref0 (operation);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


void sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self, SoundDevice* device, gfloat balance) {
	pa_cvolume cvol = {0};
	SoundDevice* _tmp0_;
	pa_cvolume _tmp1_ = {0};
	pa_cvolume _tmp2_;
	SoundDevice* _tmp3_;
	pa_channel_map _tmp4_ = {0};
	pa_channel_map _tmp5_;
	gfloat _tmp6_;
	pa_cvolume* _tmp7_;
	pa_operation* operation = NULL;
	SoundDevice* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	pa_operation* _tmp23_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = device;
	sound_device_get_cvolume (_tmp0_, &_tmp1_);
	_tmp2_ = _tmp1_;
	cvol = _tmp2_;
	_tmp3_ = device;
	sound_device_get_channel_map (_tmp3_, &_tmp4_);
	_tmp5_ = _tmp4_;
	_tmp6_ = balance;
	_tmp7_ = pa_cvolume_set_balance (&cvol, &_tmp5_, _tmp6_);
	cvol = *_tmp7_;
	operation = NULL;
	_tmp8_ = device;
	_tmp9_ = sound_device_get_input (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		pa_context* _tmp11_;
		SoundDevice* _tmp12_;
		guint32 _tmp13_;
		guint32 _tmp14_;
		pa_cvolume _tmp15_;
		pa_operation* _tmp16_;
		_tmp11_ = self->priv->_context;
		_tmp12_ = device;
		_tmp13_ = sound_device_get_index (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = cvol;
		_tmp16_ = pa_context_set_source_volume_by_index (_tmp11_, _tmp14_, &_tmp15_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp16_;
	} else {
		pa_context* _tmp17_;
		SoundDevice* _tmp18_;
		guint32 _tmp19_;
		guint32 _tmp20_;
		pa_cvolume _tmp21_;
		pa_operation* _tmp22_;
		_tmp17_ = self->priv->_context;
		_tmp18_ = device;
		_tmp19_ = sound_device_get_index (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = cvol;
		_tmp22_ = pa_context_set_sink_volume_by_index (_tmp17_, _tmp20_, &_tmp21_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp22_;
	}
	_tmp23_ = operation;
	if (_tmp23_ != NULL) {
		SoundDevice* _tmp24_;
		GeeLinkedList* _tmp25_;
		pa_operation* _tmp26_;
		_tmp24_ = device;
		_tmp25_ = _tmp24_->volume_operations;
		_tmp26_ = operation;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
	}
	_pa_operation_unref0 (operation);
}


static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->reconnect_timer_id = 0U;
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
	result = FALSE;
	return result;
}


static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data) {
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerReconnectToPulseData, _data_);
}


static void sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper (GObject *source_object, GAsyncResult *res, void *user_data) {
	SoundPulseAudioManagerReconnectToPulseData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	SoundPulseAudioManager* _tmp0_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerReconnectToPulseData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_reconnect_to_pulse_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	sound_pulse_audio_manager_reconnect_to_pulse_co (_data_);
}


static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self, GAsyncResult* _res_) {
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c, gpointer self) {
	sound_pulse_audio_manager_context_state_callback ((SoundPulseAudioManager*) self, c);
}


static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->is_ready;
	if (_data_->_tmp0_) {
		_data_->_tmp1_ = _data_->self->priv->_context;
		pa_context_disconnect (_data_->_tmp1_);
		sound_pulse_audio_manager_set_context (_data_->self, NULL);
		_data_->self->priv->is_ready = FALSE;
	}
	_data_->_tmp2_ = pa_proplist_new ();
	_data_->props = _data_->_tmp2_;
	_data_->_tmp3_ = _data_->props;
	pa_proplist_sets (_data_->_tmp3_, PA_PROP_APPLICATION_ID, "org.pantheon.switchboard.plug.sound");
	_data_->_tmp4_ = _data_->self->priv->loop;
	_data_->_tmp5_ = pa_glib_mainloop_get_api (_data_->_tmp4_);
	_data_->_tmp6_ = _data_->props;
	_data_->_tmp7_ = pa_context_new_with_proplist (_data_->_tmp5_, NULL, _data_->_tmp6_);
	_data_->_tmp8_ = _data_->_tmp7_;
	sound_pulse_audio_manager_set_context (_data_->self, _data_->_tmp8_);
	_pa_context_unref0 (_data_->_tmp8_);
	_data_->_tmp9_ = _data_->self->priv->_context;
	pa_context_set_state_callback (_data_->_tmp9_, _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
	_data_->_tmp10_ = _data_->self->priv->_context;
	_data_->_tmp11_ = pa_context_connect (_data_->_tmp10_, NULL, PA_CONTEXT_NOFAIL, NULL);
	if (_data_->_tmp11_ < 0) {
		_data_->_tmp12_ = _data_->self->priv->_context;
		_data_->_tmp13_ = pa_context_errno (_data_->_tmp12_);
		_data_->_tmp14_ = pa_strerror (_data_->_tmp13_);
		g_warning ("PulseAudioManager.vala:154: pa_context_connect() failed: %s\n", _data_->_tmp14_);
	}
	_pa_proplist_free0 (_data_->props);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c, pa_subscription_event_type_t t, guint32 idx, gpointer self) {
	sound_pulse_audio_manager_subscribe_callback ((SoundPulseAudioManager*) self, c, t, idx);
}


static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c, pa_server_info* i, gpointer self) {
	sound_pulse_audio_manager_server_info_callback ((SoundPulseAudioManager*) self, c, i);
}


static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = sound_pulse_audio_manager_reconnect_timeout ((SoundPulseAudioManager*) self);
	return result;
}


static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self, pa_context* c) {
	pa_context* _tmp0_;
	pa_context_state_t _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = c;
	_tmp1_ = pa_context_get_state (_tmp0_);
	switch (_tmp1_) {
		case PA_CONTEXT_READY:
		{
			pa_context* _tmp2_;
			pa_context* _tmp3_;
			pa_operation* _tmp4_;
			pa_operation* _tmp5_;
			pa_context* _tmp6_;
			pa_operation* _tmp7_;
			pa_operation* _tmp8_;
			_tmp2_ = c;
			pa_context_set_subscribe_callback (_tmp2_, _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
			_tmp3_ = c;
			_tmp4_ = pa_context_subscribe (_tmp3_, (((PA_SUBSCRIPTION_MASK_SERVER | PA_SUBSCRIPTION_MASK_SINK) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT, NULL, NULL);
			_tmp5_ = _tmp4_;
			_pa_operation_unref0 (_tmp5_);
			_tmp6_ = self->priv->_context;
			_tmp7_ = pa_context_get_server_info (_tmp6_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp8_ = _tmp7_;
			_pa_operation_unref0 (_tmp8_);
			self->priv->is_ready = TRUE;
			break;
		}
		case PA_CONTEXT_FAILED:
		case PA_CONTEXT_TERMINATED:
		{
			guint _tmp9_;
			_tmp9_ = self->priv->reconnect_timer_id;
			if (_tmp9_ == 0U) {
				guint _tmp10_;
				_tmp10_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
				self->priv->reconnect_timer_id = _tmp10_;
			}
			break;
		}
		default:
		{
			self->priv->is_ready = FALSE;
			break;
		}
	}
}


static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c, pa_sink_info* i, gint eol, gpointer self) {
	sound_pulse_audio_manager_sink_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}


static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c, pa_source_info* i, gint eol, gpointer self) {
	sound_pulse_audio_manager_source_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}


static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self, pa_context* c, pa_subscription_event_type_t t, guint32 index) {
	pa_subscription_event_type_t source_type = 0;
	pa_subscription_event_type_t _tmp0_;
	pa_subscription_event_type_t _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = t;
	source_type = _tmp0_ & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
	_tmp1_ = source_type;
	switch (_tmp1_) {
		case PA_SUBSCRIPTION_EVENT_SINK:
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp2_;
			pa_subscription_event_type_t _tmp3_;
			_tmp2_ = t;
			event_type = _tmp2_ & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp3_ = event_type;
			switch (_tmp3_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_context* _tmp4_;
					guint32 _tmp5_;
					pa_operation* _tmp6_;
					pa_operation* _tmp7_;
					_tmp4_ = c;
					_tmp5_ = index;
					_tmp6_ = pa_context_get_sink_info_by_index (_tmp4_, _tmp5_, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
					_tmp7_ = _tmp6_;
					_pa_operation_unref0 (_tmp7_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_context* _tmp8_;
					guint32 _tmp9_;
					pa_operation* _tmp10_;
					pa_operation* _tmp11_;
					_tmp8_ = c;
					_tmp9_ = index;
					_tmp10_ = pa_context_get_sink_info_by_index (_tmp8_, _tmp9_, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
					_tmp11_ = _tmp10_;
					_pa_operation_unref0 (_tmp11_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					SoundDevice* device = NULL;
					GeeHashMap* _tmp12_;
					guint32 _tmp13_;
					gpointer _tmp14_;
					SoundDevice* _tmp15_;
					_tmp12_ = self->priv->output_devices;
					_tmp13_ = index;
					_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, (gpointer) ((guintptr) _tmp13_));
					device = (SoundDevice*) _tmp14_;
					_tmp15_ = device;
					if (_tmp15_ != NULL) {
						SoundDevice* _tmp16_;
						GeeHashMap* _tmp17_;
						guint32 _tmp18_;
						_tmp16_ = device;
						g_signal_emit_by_name (_tmp16_, "removed");
						_tmp17_ = self->priv->output_devices;
						_tmp18_ = index;
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp17_, (gpointer) ((guintptr) _tmp18_), NULL);
					}
					_g_object_unref0 (device);
					break;
				}
				default:
				break;
			}
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SERVER:
		{
			pa_context* _tmp19_;
			pa_operation* _tmp20_;
			pa_operation* _tmp21_;
			_tmp19_ = self->priv->_context;
			_tmp20_ = pa_context_get_server_info (_tmp19_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp21_ = _tmp20_;
			_pa_operation_unref0 (_tmp21_);
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SOURCE:
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp22_;
			pa_subscription_event_type_t _tmp23_;
			_tmp22_ = t;
			event_type = _tmp22_ & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp23_ = event_type;
			switch (_tmp23_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_context* _tmp24_;
					guint32 _tmp25_;
					pa_operation* _tmp26_;
					pa_operation* _tmp27_;
					_tmp24_ = c;
					_tmp25_ = index;
					_tmp26_ = pa_context_get_source_info_by_index (_tmp24_, _tmp25_, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
					_tmp27_ = _tmp26_;
					_pa_operation_unref0 (_tmp27_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_context* _tmp28_;
					guint32 _tmp29_;
					pa_operation* _tmp30_;
					pa_operation* _tmp31_;
					_tmp28_ = c;
					_tmp29_ = index;
					_tmp30_ = pa_context_get_source_info_by_index (_tmp28_, _tmp29_, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
					_tmp31_ = _tmp30_;
					_pa_operation_unref0 (_tmp31_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					SoundDevice* device = NULL;
					GeeHashMap* _tmp32_;
					guint32 _tmp33_;
					gpointer _tmp34_;
					SoundDevice* _tmp35_;
					_tmp32_ = self->priv->input_devices;
					_tmp33_ = index;
					_tmp34_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp32_, (gpointer) ((guintptr) _tmp33_));
					device = (SoundDevice*) _tmp34_;
					_tmp35_ = device;
					if (_tmp35_ != NULL) {
						SoundDevice* _tmp36_;
						GeeHashMap* _tmp37_;
						guint32 _tmp38_;
						_tmp36_ = device;
						g_signal_emit_by_name (_tmp36_, "removed");
						_tmp37_ = self->priv->input_devices;
						_tmp38_ = index;
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp37_, (gpointer) ((guintptr) _tmp38_), NULL);
					}
					_g_object_unref0 (device);
					break;
				}
				default:
				break;
			}
			break;
		}
		default:
		break;
	}
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->device);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static gboolean __lambda6_ (Block2Data* _data2_, pa_operation* operation) {
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	pa_operation* _tmp0_;
	pa_operation_state_t _tmp1_;
	self = _data2_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	_tmp0_ = operation;
	_tmp1_ = pa_operation_get_state (_tmp0_);
	if (_tmp1_ != PA_OPERATION_RUNNING) {
		SoundDevice* _tmp2_;
		GeeLinkedList* _tmp3_;
		pa_operation* _tmp4_;
		_tmp2_ = _data2_->device;
		_tmp3_ = _tmp2_->volume_operations;
		_tmp4_ = operation;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp3_, _tmp4_);
	}
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}


static gboolean ___lambda6__gee_forall_func (gpointer g, gpointer self) {
	gboolean result;
	result = __lambda6_ (self, (pa_operation*) g);
	return result;
}


static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self, pa_context* c, pa_source_info* i, gint eol) {
	Block2Data* _data2_;
	pa_source_info* _tmp0_;
	pa_source_info* _tmp1_;
	guint32 _tmp2_;
	gboolean is_new = FALSE;
	GeeHashMap* _tmp3_;
	pa_source_info* _tmp4_;
	guint32 _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundDevice* _tmp15_;
	SoundDevice* _tmp16_;
	pa_source_info* _tmp17_;
	const gchar* _tmp18_;
	SoundDevice* _tmp19_;
	pa_source_info* _tmp20_;
	const gchar* _tmp21_;
	SoundDevice* _tmp22_;
	pa_source_info* _tmp23_;
	gint _tmp24_;
	SoundDevice* _tmp25_;
	pa_source_info* _tmp26_;
	pa_cvolume _tmp27_;
	SoundDevice* _tmp28_;
	pa_source_info* _tmp29_;
	pa_channel_map _tmp30_;
	SoundDevice* _tmp31_;
	pa_source_info* _tmp32_;
	pa_source_info* _tmp33_;
	pa_channel_map _tmp34_;
	gfloat _tmp35_;
	SoundDevice* _tmp36_;
	GeeLinkedList* _tmp37_;
	SoundDevice* _tmp38_;
	GeeArrayList* _tmp39_;
	GeeArrayList* _tmp40_;
	SoundDevice* _tmp41_;
	SoundDevice* _tmp80_;
	GeeLinkedList* _tmp81_;
	gboolean _tmp82_;
	gboolean _tmp83_;
	gchar* form_factor = NULL;
	pa_source_info* _tmp88_;
	pa_proplist* _tmp89_;
	const gchar* _tmp90_;
	gchar* _tmp91_;
	const gchar* _tmp92_;
	SoundDevice* _tmp95_;
	pa_source_info* _tmp96_;
	const gchar* _tmp97_;
	const gchar* _tmp98_;
	SoundDevice* _tmp99_;
	gboolean _tmp100_;
	gboolean _tmp101_;
	gboolean _tmp103_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = i;
	if (_tmp0_ == NULL) {
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	_tmp1_ = i;
	_tmp2_ = (*_tmp1_).monitor_of_sink;
	if (_tmp2_ != PA_INVALID_INDEX) {
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	_data2_->device = NULL;
	_tmp3_ = self->priv->input_devices;
	_tmp4_ = i;
	_tmp5_ = (*_tmp4_).index;
	_tmp6_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, (gpointer) ((guintptr) _tmp5_));
	is_new = !_tmp6_;
	_tmp7_ = is_new;
	if (_tmp7_) {
		pa_source_info* _tmp8_;
		guint32 _tmp9_;
		SoundDevice* _tmp10_;
		_tmp8_ = i;
		_tmp9_ = (*_tmp8_).index;
		_tmp10_ = sound_device_new (_tmp9_);
		_g_object_unref0 (_data2_->device);
		_data2_->device = _tmp10_;
	} else {
		GeeHashMap* _tmp11_;
		pa_source_info* _tmp12_;
		guint32 _tmp13_;
		gpointer _tmp14_;
		_tmp11_ = self->priv->input_devices;
		_tmp12_ = i;
		_tmp13_ = (*_tmp12_).index;
		_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, (gpointer) ((guintptr) _tmp13_));
		_g_object_unref0 (_data2_->device);
		_data2_->device = (SoundDevice*) _tmp14_;
	}
	_tmp15_ = _data2_->device;
	sound_device_set_input (_tmp15_, TRUE);
	_tmp16_ = _data2_->device;
	_tmp17_ = i;
	_tmp18_ = (*_tmp17_).name;
	sound_device_set_name (_tmp16_, _tmp18_);
	_tmp19_ = _data2_->device;
	_tmp20_ = i;
	_tmp21_ = (*_tmp20_).description;
	sound_device_set_display_name (_tmp19_, _tmp21_);
	_tmp22_ = _data2_->device;
	_tmp23_ = i;
	_tmp24_ = (*_tmp23_).mute;
	sound_device_set_is_muted (_tmp22_, _tmp24_ != 0);
	_tmp25_ = _data2_->device;
	_tmp26_ = i;
	_tmp27_ = (*_tmp26_).volume;
	sound_device_set_cvolume (_tmp25_, &_tmp27_);
	_tmp28_ = _data2_->device;
	_tmp29_ = i;
	_tmp30_ = (*_tmp29_).channel_map;
	sound_device_set_channel_map (_tmp28_, &_tmp30_);
	_tmp31_ = _data2_->device;
	_tmp32_ = i;
	_tmp33_ = i;
	_tmp34_ = (*_tmp33_).channel_map;
	_tmp35_ = pa_cvolume_get_balance (&(*_tmp32_).volume, &_tmp34_);
	sound_device_set_balance (_tmp31_, _tmp35_);
	_tmp36_ = _data2_->device;
	_tmp37_ = _tmp36_->volume_operations;
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp37_, ___lambda6__gee_forall_func, _data2_);
	_tmp38_ = _data2_->device;
	_tmp39_ = sound_device_get_ports (_tmp38_);
	_tmp40_ = _tmp39_;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp40_);
	_tmp41_ = _data2_->device;
	sound_device_set_default_port (_tmp41_, NULL);
	{
		gint idx = 0;
		idx = 0;
		{
			gboolean _tmp42_ = FALSE;
			_tmp42_ = TRUE;
			while (TRUE) {
				gint _tmp44_;
				pa_source_info* _tmp45_;
				guint32 _tmp46_;
				SoundDevicePort* new_port = NULL;
				SoundDevicePort* _tmp47_;
				SoundDevicePort* _tmp48_;
				pa_source_info* _tmp49_;
				pa_source_port_info** _tmp50_;
				gint _tmp50__length1;
				gint _tmp51_;
				pa_source_port_info* _tmp52_;
				const gchar* _tmp53_;
				gchar* _tmp54_;
				SoundDevicePort* _tmp55_;
				pa_source_info* _tmp56_;
				pa_source_port_info** _tmp57_;
				gint _tmp57__length1;
				gint _tmp58_;
				pa_source_port_info* _tmp59_;
				const gchar* _tmp60_;
				gchar* _tmp61_;
				SoundDevicePort* _tmp62_;
				pa_source_info* _tmp63_;
				pa_source_port_info** _tmp64_;
				gint _tmp64__length1;
				gint _tmp65_;
				pa_source_port_info* _tmp66_;
				guint32 _tmp67_;
				SoundDevice* _tmp68_;
				GeeArrayList* _tmp69_;
				GeeArrayList* _tmp70_;
				SoundDevicePort* _tmp71_;
				pa_source_info* _tmp72_;
				pa_source_port_info** _tmp73_;
				gint _tmp73__length1;
				gint _tmp74_;
				pa_source_port_info* _tmp75_;
				pa_source_info* _tmp76_;
				pa_source_port_info* _tmp77_;
				if (!_tmp42_) {
					gint _tmp43_;
					_tmp43_ = idx;
					idx = _tmp43_ + 1;
				}
				_tmp42_ = FALSE;
				_tmp44_ = idx;
				_tmp45_ = i;
				_tmp46_ = (*_tmp45_).n_ports;
				if (!(((guint32) _tmp44_) < _tmp46_)) {
					break;
				}
				_tmp47_ = sound_device_port_new ();
				new_port = _tmp47_;
				_tmp48_ = new_port;
				_tmp49_ = i;
				_tmp50_ = (*_tmp49_).ports;
				_tmp50__length1 = (*_tmp49_).n_ports;
				_tmp51_ = idx;
				_tmp52_ = _tmp50_[_tmp51_];
				_tmp53_ = (*_tmp52_).name;
				_tmp54_ = g_strdup (_tmp53_);
				_g_free0 (_tmp48_->name);
				_tmp48_->name = _tmp54_;
				_tmp55_ = new_port;
				_tmp56_ = i;
				_tmp57_ = (*_tmp56_).ports;
				_tmp57__length1 = (*_tmp56_).n_ports;
				_tmp58_ = idx;
				_tmp59_ = _tmp57_[_tmp58_];
				_tmp60_ = (*_tmp59_).description;
				_tmp61_ = g_strdup (_tmp60_);
				_g_free0 (_tmp55_->description);
				_tmp55_->description = _tmp61_;
				_tmp62_ = new_port;
				_tmp63_ = i;
				_tmp64_ = (*_tmp63_).ports;
				_tmp64__length1 = (*_tmp63_).n_ports;
				_tmp65_ = idx;
				_tmp66_ = _tmp64_[_tmp65_];
				_tmp67_ = (*_tmp66_).priority;
				_tmp62_->priority = _tmp67_;
				_tmp68_ = _data2_->device;
				_tmp69_ = sound_device_get_ports (_tmp68_);
				_tmp70_ = _tmp69_;
				_tmp71_ = new_port;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp70_, _tmp71_);
				_tmp72_ = i;
				_tmp73_ = (*_tmp72_).ports;
				_tmp73__length1 = (*_tmp72_).n_ports;
				_tmp74_ = idx;
				_tmp75_ = _tmp73_[_tmp74_];
				_tmp76_ = i;
				_tmp77_ = (*_tmp76_).active_port;
				if (_tmp75_ == _tmp77_) {
					SoundDevice* _tmp78_;
					SoundDevicePort* _tmp79_;
					_tmp78_ = _data2_->device;
					_tmp79_ = new_port;
					sound_device_set_default_port (_tmp78_, _tmp79_);
				}
				_sound_device_port_unref0 (new_port);
			}
		}
	}
	_tmp80_ = _data2_->device;
	_tmp81_ = _tmp80_->volume_operations;
	_tmp82_ = gee_collection_get_is_empty ((GeeCollection*) _tmp81_);
	_tmp83_ = _tmp82_;
	if (_tmp83_) {
		SoundDevice* _tmp84_;
		pa_source_info* _tmp85_;
		pa_volume_t _tmp86_;
		gdouble _tmp87_;
		_tmp84_ = _data2_->device;
		_tmp85_ = i;
		_tmp86_ = pa_cvolume_max (&(*_tmp85_).volume);
		_tmp87_ = sound_pulse_audio_manager_volume_to_double (_tmp86_);
		sound_device_set_volume (_tmp84_, _tmp87_);
	}
	_tmp88_ = i;
	_tmp89_ = (*_tmp88_).proplist;
	_tmp90_ = pa_proplist_gets (_tmp89_, PA_PROP_DEVICE_FORM_FACTOR);
	_tmp91_ = g_strdup (_tmp90_);
	form_factor = _tmp91_;
	_tmp92_ = form_factor;
	if (_tmp92_ != NULL) {
		SoundDevice* _tmp93_;
		const gchar* _tmp94_;
		_tmp93_ = _data2_->device;
		_tmp94_ = form_factor;
		sound_device_set_form_factor (_tmp93_, _tmp94_);
	}
	_tmp95_ = _data2_->device;
	_tmp96_ = i;
	_tmp97_ = (*_tmp96_).name;
	_tmp98_ = self->priv->default_source_name;
	sound_device_set_is_default (_tmp95_, g_strcmp0 (_tmp97_, _tmp98_) == 0);
	_tmp99_ = _data2_->device;
	_tmp100_ = sound_device_get_is_default (_tmp99_);
	_tmp101_ = _tmp100_;
	if (_tmp101_) {
		SoundDevice* _tmp102_;
		_tmp102_ = _data2_->device;
		sound_pulse_audio_manager_set_default_input (self, _tmp102_);
	}
	_tmp103_ = is_new;
	if (_tmp103_) {
		GeeHashMap* _tmp104_;
		pa_source_info* _tmp105_;
		guint32 _tmp106_;
		SoundDevice* _tmp107_;
		SoundDevice* _tmp108_;
		_tmp104_ = self->priv->input_devices;
		_tmp105_ = i;
		_tmp106_ = (*_tmp105_).index;
		_tmp107_ = _data2_->device;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp104_, (gpointer) ((guintptr) _tmp106_), _tmp107_);
		_tmp108_ = _data2_->device;
		g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp108_);
	}
	_g_free0 (form_factor);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->device);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}


static gboolean __lambda5_ (Block3Data* _data3_, pa_operation* operation) {
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	pa_operation* _tmp0_;
	pa_operation_state_t _tmp1_;
	self = _data3_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	_tmp0_ = operation;
	_tmp1_ = pa_operation_get_state (_tmp0_);
	if (_tmp1_ != PA_OPERATION_RUNNING) {
		SoundDevice* _tmp2_;
		GeeLinkedList* _tmp3_;
		pa_operation* _tmp4_;
		_tmp2_ = _data3_->device;
		_tmp3_ = _tmp2_->volume_operations;
		_tmp4_ = operation;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp3_, _tmp4_);
	}
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}


static gboolean ___lambda5__gee_forall_func (gpointer g, gpointer self) {
	gboolean result;
	result = __lambda5_ (self, (pa_operation*) g);
	return result;
}


static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self, pa_context* c, pa_sink_info* i, gint eol) {
	Block3Data* _data3_;
	pa_sink_info* _tmp0_;
	gboolean is_new = FALSE;
	GeeHashMap* _tmp1_;
	pa_sink_info* _tmp2_;
	guint32 _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	SoundDevice* _tmp13_;
	SoundDevice* _tmp14_;
	pa_sink_info* _tmp15_;
	const gchar* _tmp16_;
	SoundDevice* _tmp17_;
	pa_sink_info* _tmp18_;
	const gchar* _tmp19_;
	SoundDevice* _tmp20_;
	pa_sink_info* _tmp21_;
	gint _tmp22_;
	SoundDevice* _tmp23_;
	pa_sink_info* _tmp24_;
	pa_cvolume _tmp25_;
	SoundDevice* _tmp26_;
	pa_sink_info* _tmp27_;
	pa_channel_map _tmp28_;
	SoundDevice* _tmp29_;
	pa_sink_info* _tmp30_;
	pa_sink_info* _tmp31_;
	pa_channel_map _tmp32_;
	gfloat _tmp33_;
	SoundDevice* _tmp34_;
	GeeLinkedList* _tmp35_;
	SoundDevice* _tmp36_;
	GeeArrayList* _tmp37_;
	GeeArrayList* _tmp38_;
	SoundDevice* _tmp39_;
	SoundDevice* _tmp78_;
	GeeLinkedList* _tmp79_;
	gboolean _tmp80_;
	gboolean _tmp81_;
	gchar* form_factor = NULL;
	pa_sink_info* _tmp86_;
	pa_proplist* _tmp87_;
	const gchar* _tmp88_;
	gchar* _tmp89_;
	const gchar* _tmp90_;
	SoundDevice* _tmp93_;
	pa_sink_info* _tmp94_;
	const gchar* _tmp95_;
	const gchar* _tmp96_;
	SoundDevice* _tmp97_;
	gboolean _tmp98_;
	gboolean _tmp99_;
	gboolean _tmp101_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = i;
	if (_tmp0_ == NULL) {
		block3_data_unref (_data3_);
		_data3_ = NULL;
		return;
	}
	_data3_->device = NULL;
	_tmp1_ = self->priv->output_devices;
	_tmp2_ = i;
	_tmp3_ = (*_tmp2_).index;
	_tmp4_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((guintptr) _tmp3_));
	is_new = !_tmp4_;
	_tmp5_ = is_new;
	if (_tmp5_) {
		pa_sink_info* _tmp6_;
		guint32 _tmp7_;
		SoundDevice* _tmp8_;
		_tmp6_ = i;
		_tmp7_ = (*_tmp6_).index;
		_tmp8_ = sound_device_new (_tmp7_);
		_g_object_unref0 (_data3_->device);
		_data3_->device = _tmp8_;
	} else {
		GeeHashMap* _tmp9_;
		pa_sink_info* _tmp10_;
		guint32 _tmp11_;
		gpointer _tmp12_;
		_tmp9_ = self->priv->output_devices;
		_tmp10_ = i;
		_tmp11_ = (*_tmp10_).index;
		_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, (gpointer) ((guintptr) _tmp11_));
		_g_object_unref0 (_data3_->device);
		_data3_->device = (SoundDevice*) _tmp12_;
	}
	_tmp13_ = _data3_->device;
	sound_device_set_input (_tmp13_, FALSE);
	_tmp14_ = _data3_->device;
	_tmp15_ = i;
	_tmp16_ = (*_tmp15_).name;
	sound_device_set_name (_tmp14_, _tmp16_);
	_tmp17_ = _data3_->device;
	_tmp18_ = i;
	_tmp19_ = (*_tmp18_).description;
	sound_device_set_display_name (_tmp17_, _tmp19_);
	_tmp20_ = _data3_->device;
	_tmp21_ = i;
	_tmp22_ = (*_tmp21_).mute;
	sound_device_set_is_muted (_tmp20_, _tmp22_ != 0);
	_tmp23_ = _data3_->device;
	_tmp24_ = i;
	_tmp25_ = (*_tmp24_).volume;
	sound_device_set_cvolume (_tmp23_, &_tmp25_);
	_tmp26_ = _data3_->device;
	_tmp27_ = i;
	_tmp28_ = (*_tmp27_).channel_map;
	sound_device_set_channel_map (_tmp26_, &_tmp28_);
	_tmp29_ = _data3_->device;
	_tmp30_ = i;
	_tmp31_ = i;
	_tmp32_ = (*_tmp31_).channel_map;
	_tmp33_ = pa_cvolume_get_balance (&(*_tmp30_).volume, &_tmp32_);
	sound_device_set_balance (_tmp29_, _tmp33_);
	_tmp34_ = _data3_->device;
	_tmp35_ = _tmp34_->volume_operations;
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp35_, ___lambda5__gee_forall_func, _data3_);
	_tmp36_ = _data3_->device;
	_tmp37_ = sound_device_get_ports (_tmp36_);
	_tmp38_ = _tmp37_;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp38_);
	_tmp39_ = _data3_->device;
	sound_device_set_default_port (_tmp39_, NULL);
	{
		gint idx = 0;
		idx = 0;
		{
			gboolean _tmp40_ = FALSE;
			_tmp40_ = TRUE;
			while (TRUE) {
				gint _tmp42_;
				pa_sink_info* _tmp43_;
				guint32 _tmp44_;
				SoundDevicePort* new_port = NULL;
				SoundDevicePort* _tmp45_;
				SoundDevicePort* _tmp46_;
				pa_sink_info* _tmp47_;
				pa_sink_port_info** _tmp48_;
				gint _tmp48__length1;
				gint _tmp49_;
				pa_sink_port_info* _tmp50_;
				const gchar* _tmp51_;
				gchar* _tmp52_;
				SoundDevicePort* _tmp53_;
				pa_sink_info* _tmp54_;
				pa_sink_port_info** _tmp55_;
				gint _tmp55__length1;
				gint _tmp56_;
				pa_sink_port_info* _tmp57_;
				const gchar* _tmp58_;
				gchar* _tmp59_;
				SoundDevicePort* _tmp60_;
				pa_sink_info* _tmp61_;
				pa_sink_port_info** _tmp62_;
				gint _tmp62__length1;
				gint _tmp63_;
				pa_sink_port_info* _tmp64_;
				guint32 _tmp65_;
				SoundDevice* _tmp66_;
				GeeArrayList* _tmp67_;
				GeeArrayList* _tmp68_;
				SoundDevicePort* _tmp69_;
				pa_sink_info* _tmp70_;
				pa_sink_port_info** _tmp71_;
				gint _tmp71__length1;
				gint _tmp72_;
				pa_sink_port_info* _tmp73_;
				pa_sink_info* _tmp74_;
				pa_sink_port_info* _tmp75_;
				if (!_tmp40_) {
					gint _tmp41_;
					_tmp41_ = idx;
					idx = _tmp41_ + 1;
				}
				_tmp40_ = FALSE;
				_tmp42_ = idx;
				_tmp43_ = i;
				_tmp44_ = (*_tmp43_).n_ports;
				if (!(((guint32) _tmp42_) < _tmp44_)) {
					break;
				}
				_tmp45_ = sound_device_port_new ();
				new_port = _tmp45_;
				_tmp46_ = new_port;
				_tmp47_ = i;
				_tmp48_ = (*_tmp47_).ports;
				_tmp48__length1 = (*_tmp47_).n_ports;
				_tmp49_ = idx;
				_tmp50_ = _tmp48_[_tmp49_];
				_tmp51_ = (*_tmp50_).name;
				_tmp52_ = g_strdup (_tmp51_);
				_g_free0 (_tmp46_->name);
				_tmp46_->name = _tmp52_;
				_tmp53_ = new_port;
				_tmp54_ = i;
				_tmp55_ = (*_tmp54_).ports;
				_tmp55__length1 = (*_tmp54_).n_ports;
				_tmp56_ = idx;
				_tmp57_ = _tmp55_[_tmp56_];
				_tmp58_ = (*_tmp57_).description;
				_tmp59_ = g_strdup (_tmp58_);
				_g_free0 (_tmp53_->description);
				_tmp53_->description = _tmp59_;
				_tmp60_ = new_port;
				_tmp61_ = i;
				_tmp62_ = (*_tmp61_).ports;
				_tmp62__length1 = (*_tmp61_).n_ports;
				_tmp63_ = idx;
				_tmp64_ = _tmp62_[_tmp63_];
				_tmp65_ = (*_tmp64_).priority;
				_tmp60_->priority = _tmp65_;
				_tmp66_ = _data3_->device;
				_tmp67_ = sound_device_get_ports (_tmp66_);
				_tmp68_ = _tmp67_;
				_tmp69_ = new_port;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp68_, _tmp69_);
				_tmp70_ = i;
				_tmp71_ = (*_tmp70_).ports;
				_tmp71__length1 = (*_tmp70_).n_ports;
				_tmp72_ = idx;
				_tmp73_ = _tmp71_[_tmp72_];
				_tmp74_ = i;
				_tmp75_ = (*_tmp74_).active_port;
				if (_tmp73_ == _tmp75_) {
					SoundDevice* _tmp76_;
					SoundDevicePort* _tmp77_;
					_tmp76_ = _data3_->device;
					_tmp77_ = new_port;
					sound_device_set_default_port (_tmp76_, _tmp77_);
				}
				_sound_device_port_unref0 (new_port);
			}
		}
	}
	_tmp78_ = _data3_->device;
	_tmp79_ = _tmp78_->volume_operations;
	_tmp80_ = gee_collection_get_is_empty ((GeeCollection*) _tmp79_);
	_tmp81_ = _tmp80_;
	if (_tmp81_) {
		SoundDevice* _tmp82_;
		pa_sink_info* _tmp83_;
		pa_volume_t _tmp84_;
		gdouble _tmp85_;
		_tmp82_ = _data3_->device;
		_tmp83_ = i;
		_tmp84_ = pa_cvolume_max (&(*_tmp83_).volume);
		_tmp85_ = sound_pulse_audio_manager_volume_to_double (_tmp84_);
		sound_device_set_volume (_tmp82_, _tmp85_);
	}
	_tmp86_ = i;
	_tmp87_ = (*_tmp86_).proplist;
	_tmp88_ = pa_proplist_gets (_tmp87_, PA_PROP_DEVICE_FORM_FACTOR);
	_tmp89_ = g_strdup (_tmp88_);
	form_factor = _tmp89_;
	_tmp90_ = form_factor;
	if (_tmp90_ != NULL) {
		SoundDevice* _tmp91_;
		const gchar* _tmp92_;
		_tmp91_ = _data3_->device;
		_tmp92_ = form_factor;
		sound_device_set_form_factor (_tmp91_, _tmp92_);
	}
	_tmp93_ = _data3_->device;
	_tmp94_ = i;
	_tmp95_ = (*_tmp94_).name;
	_tmp96_ = self->priv->default_sink_name;
	sound_device_set_is_default (_tmp93_, g_strcmp0 (_tmp95_, _tmp96_) == 0);
	_tmp97_ = _data3_->device;
	_tmp98_ = sound_device_get_is_default (_tmp97_);
	_tmp99_ = _tmp98_;
	if (_tmp99_) {
		SoundDevice* _tmp100_;
		_tmp100_ = _data3_->device;
		sound_pulse_audio_manager_set_default_output (self, _tmp100_);
	}
	_tmp101_ = is_new;
	if (_tmp101_) {
		GeeHashMap* _tmp102_;
		pa_sink_info* _tmp103_;
		guint32 _tmp104_;
		SoundDevice* _tmp105_;
		SoundDevice* _tmp106_;
		_tmp102_ = self->priv->output_devices;
		_tmp103_ = i;
		_tmp104_ = (*_tmp103_).index;
		_tmp105_ = _data3_->device;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp102_, (gpointer) ((guintptr) _tmp104_), _tmp105_);
		_tmp106_ = _data3_->device;
		g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp106_);
	}
	_g_free0 (form_factor);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}


static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self, pa_context* c, pa_server_info* i) {
	pa_server_info* _tmp0_;
	pa_server_info* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	pa_server_info* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	pa_context* _tmp7_;
	pa_operation* _tmp8_;
	pa_operation* _tmp9_;
	pa_context* _tmp10_;
	pa_operation* _tmp11_;
	pa_operation* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = i;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = i;
	_tmp2_ = (*_tmp1_).default_source_name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (self->priv->default_source_name);
	self->priv->default_source_name = _tmp3_;
	_tmp4_ = i;
	_tmp5_ = (*_tmp4_).default_sink_name;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (self->priv->default_sink_name);
	self->priv->default_sink_name = _tmp6_;
	_tmp7_ = self->priv->_context;
	_tmp8_ = pa_context_get_sink_info_list (_tmp7_, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
	_tmp9_ = _tmp8_;
	_pa_operation_unref0 (_tmp9_);
	_tmp10_ = self->priv->_context;
	_tmp11_ = pa_context_get_source_info_list (_tmp10_, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
	_tmp12_ = _tmp11_;
	_pa_operation_unref0 (_tmp12_);
}


static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self, pa_context* c, pa_ext_stream_restore_info* info, gint eol) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	pa_ext_stream_restore_info new_info = {0};
	pa_ext_stream_restore_info* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	pa_channel_map _tmp9_;
	pa_ext_stream_restore_info* _tmp10_;
	pa_cvolume _tmp11_;
	pa_ext_stream_restore_info* _tmp12_;
	gint _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	pa_context* _tmp16_;
	pa_ext_stream_restore_info _tmp17_;
	pa_ext_stream_restore_info* _tmp18_;
	pa_ext_stream_restore_info* _tmp19_;
	gint _tmp19__length1;
	pa_operation* _tmp20_;
	pa_operation* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp1_ = eol;
	if (_tmp1_ != 0) {
		_tmp0_ = TRUE;
	} else {
		pa_ext_stream_restore_info* _tmp2_;
		const gchar* _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = info;
		_tmp3_ = (*_tmp2_).name;
		_tmp4_ = g_str_has_prefix (_tmp3_, "sink-input-by");
		_tmp0_ = !_tmp4_;
	}
	if (_tmp0_) {
		return;
	}
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
	_tmp5_ = info;
	_tmp6_ = (*_tmp5_).name;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 (new_info.name);
	new_info.name = _tmp7_;
	_tmp8_ = info;
	_tmp9_ = (*_tmp8_).channel_map;
	new_info.channel_map = _tmp9_;
	_tmp10_ = info;
	_tmp11_ = (*_tmp10_).volume;
	new_info.volume = _tmp11_;
	_tmp12_ = info;
	_tmp13_ = (*_tmp12_).mute;
	new_info.mute = _tmp13_;
	_tmp14_ = self->priv->default_sink_name;
	_tmp15_ = g_strdup (_tmp14_);
	_g_free0 (new_info.device);
	new_info.device = _tmp15_;
	_tmp16_ = c;
	_tmp17_ = new_info;
	_tmp18_ = g_new0 (pa_ext_stream_restore_info, 1);
	_tmp18_[0] = _tmp17_;
	_tmp19_ = _tmp18_;
	_tmp19__length1 = 1;
	_tmp20_ = pa_ext_stream_restore_write (_tmp16_, PA_UPDATE_REPLACE, _tmp19_, 1, 1, NULL, NULL);
	_tmp21_ = _tmp20_;
	_pa_operation_unref0 (_tmp21_);
	_tmp19_ = (g_free (_tmp19_), NULL);
	 (&new_info);
}


static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self, pa_context* c, pa_ext_stream_restore_info* info, gint eol) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	pa_ext_stream_restore_info new_info = {0};
	pa_ext_stream_restore_info* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	pa_channel_map _tmp9_;
	pa_ext_stream_restore_info* _tmp10_;
	pa_cvolume _tmp11_;
	pa_ext_stream_restore_info* _tmp12_;
	gint _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	pa_context* _tmp16_;
	pa_ext_stream_restore_info _tmp17_;
	pa_ext_stream_restore_info* _tmp18_;
	pa_ext_stream_restore_info* _tmp19_;
	gint _tmp19__length1;
	pa_operation* _tmp20_;
	pa_operation* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp1_ = eol;
	if (_tmp1_ != 0) {
		_tmp0_ = TRUE;
	} else {
		pa_ext_stream_restore_info* _tmp2_;
		const gchar* _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = info;
		_tmp3_ = (*_tmp2_).name;
		_tmp4_ = g_str_has_prefix (_tmp3_, "source-output-by");
		_tmp0_ = !_tmp4_;
	}
	if (_tmp0_) {
		return;
	}
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
	_tmp5_ = info;
	_tmp6_ = (*_tmp5_).name;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 (new_info.name);
	new_info.name = _tmp7_;
	_tmp8_ = info;
	_tmp9_ = (*_tmp8_).channel_map;
	new_info.channel_map = _tmp9_;
	_tmp10_ = info;
	_tmp11_ = (*_tmp10_).volume;
	new_info.volume = _tmp11_;
	_tmp12_ = info;
	_tmp13_ = (*_tmp12_).mute;
	new_info.mute = _tmp13_;
	_tmp14_ = self->priv->default_source_name;
	_tmp15_ = g_strdup (_tmp14_);
	_g_free0 (new_info.device);
	new_info.device = _tmp15_;
	_tmp16_ = c;
	_tmp17_ = new_info;
	_tmp18_ = g_new0 (pa_ext_stream_restore_info, 1);
	_tmp18_[0] = _tmp17_;
	_tmp19_ = _tmp18_;
	_tmp19__length1 = 1;
	_tmp20_ = pa_ext_stream_restore_write (_tmp16_, PA_UPDATE_REPLACE, _tmp19_, 1, 1, NULL, NULL);
	_tmp21_ = _tmp20_;
	_pa_operation_unref0 (_tmp21_);
	_tmp19_ = (g_free (_tmp19_), NULL);
	 (&new_info);
}


static gdouble sound_pulse_audio_manager_volume_to_double (pa_volume_t vol) {
	gdouble result = 0.0;
	gdouble tmp = 0.0;
	pa_volume_t _tmp0_;
	_tmp0_ = vol;
	tmp = (gdouble) (_tmp0_ - PA_VOLUME_MUTED);
	result = (100 * tmp) / ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED));
	return result;
}


static pa_volume_t sound_pulse_audio_manager_double_to_volume (gdouble vol) {
	pa_volume_t result = 0U;
	gdouble tmp = 0.0;
	gdouble _tmp0_;
	_tmp0_ = vol;
	tmp = (((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED)) * _tmp0_) / 100;
	result = ((pa_volume_t) tmp) + PA_VOLUME_MUTED;
	return result;
}


pa_context* sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self) {
	pa_context* result;
	pa_context* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_context;
	result = _tmp0_;
	return result;
}


static gpointer _pa_context_ref0 (gpointer self) {
	return self ? pa_context_ref (self) : NULL;
}


static void sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self, pa_context* value) {
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_context (self) != value) {
		pa_context* _tmp0_;
		pa_context* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _pa_context_ref0 (_tmp0_);
		_pa_context_unref0 (self->priv->_context);
		self->priv->_context = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY]);
	}
}


SoundDevice* sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self) {
	SoundDevice* result;
	SoundDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_output;
	result = _tmp0_;
	return result;
}


static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self, SoundDevice* value) {
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_default_output (self) != value) {
		SoundDevice* _tmp0_;
		SoundDevice* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_default_output);
		self->priv->_default_output = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY]);
	}
}


SoundDevice* sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self) {
	SoundDevice* result;
	SoundDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_input;
	result = _tmp0_;
	return result;
}


static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self, SoundDevice* value) {
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_default_input (self) != value) {
		SoundDevice* _tmp0_;
		SoundDevice* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_default_input);
		self->priv->_default_input = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY]);
	}
}


static GObject * sound_pulse_audio_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SoundPulseAudioManager * self;
	pa_glib_mainloop* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	parent_class = G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	_tmp0_ = pa_glib_mainloop_new (NULL);
	_pa_glib_mainloop_free0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->input_devices);
	self->priv->input_devices = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->output_devices);
	self->priv->output_devices = _tmp2_;
	_tmp3_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->volume_operations);
	self->priv->volume_operations = _tmp3_;
	return obj;
}


static void sound_pulse_audio_manager_class_init (SoundPulseAudioManagerClass * klass) {
	sound_pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SoundPulseAudioManagerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_pulse_audio_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_pulse_audio_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = sound_pulse_audio_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = sound_pulse_audio_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY] = g_param_spec_pointer ("context", "context", "context", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY] = g_param_spec_object ("default-output", "default-output", "default-output", SOUND_TYPE_DEVICE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY] = g_param_spec_object ("default-input", "default-input", "default-input", SOUND_TYPE_DEVICE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL] = g_signal_new ("new-device", SOUND_TYPE_PULSE_AUDIO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SOUND_TYPE_DEVICE);
}


static void sound_pulse_audio_manager_instance_init (SoundPulseAudioManager * self) {
	self->priv = SOUND_PULSE_AUDIO_MANAGER_GET_PRIVATE (self);
	self->priv->is_ready = FALSE;
	self->priv->reconnect_timer_id = 0U;
}


static void sound_pulse_audio_manager_finalize (GObject * obj) {
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	_pa_context_unref0 (self->priv->_context);
	_pa_glib_mainloop_free0 (self->priv->loop);
	_g_object_unref0 (self->priv->input_devices);
	_g_object_unref0 (self->priv->output_devices);
	_g_object_unref0 (self->priv->_default_output);
	_g_object_unref0 (self->priv->_default_input);
	_g_free0 (self->priv->default_source_name);
	_g_free0 (self->priv->default_sink_name);
	_g_object_unref0 (self->priv->volume_operations);
	G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class)->finalize (obj);
}


GType sound_pulse_audio_manager_get_type (void) {
	static volatile gsize sound_pulse_audio_manager_type_id__volatile = 0;
	if (g_once_init_enter (&sound_pulse_audio_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundPulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPulseAudioManager), 0, (GInstanceInitFunc) sound_pulse_audio_manager_instance_init, NULL };
		GType sound_pulse_audio_manager_type_id;
		sound_pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundPulseAudioManager", &g_define_type_info, 0);
		g_once_init_leave (&sound_pulse_audio_manager_type_id__volatile, sound_pulse_audio_manager_type_id);
	}
	return sound_pulse_audio_manager_type_id__volatile;
}


static void _vala_sound_pulse_audio_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	switch (property_id) {
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
		g_value_set_pointer (value, sound_pulse_audio_manager_get_context (self));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
		g_value_set_object (value, sound_pulse_audio_manager_get_default_output (self));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
		g_value_set_object (value, sound_pulse_audio_manager_get_default_input (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_sound_pulse_audio_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	switch (property_id) {
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
		sound_pulse_audio_manager_set_context (self, g_value_get_pointer (value));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
		sound_pulse_audio_manager_set_default_output (self, g_value_get_object (value));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
		sound_pulse_audio_manager_set_default_input (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



